| The Gaudi Framework v29r1 (5cd95fa2)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
TagCollectionStream Class Reference

Specialized output stream class for event tag collections, where the basic Event entry point should be placed as well into the collection itself. More...

`#include <PersistencySvc/TagCollectionStream.h>`

Inheritance diagram for TagCollectionStream:
[legend]
Collaboration diagram for TagCollectionStream:
[legend]

## Public Member Functions
| TagCollectionStream (const std::string &name, ISvcLocator *pSvcLocator)
| Standard algorithm Constructor. More...
| ~TagCollectionStream () override=default
| Standard Destructor. More...
StatusCode | initialize () override
| Initialize TagCollectionStream. More...
StatusCode | finalize () override
| Terminate TagCollectionStream. More...
Public Member Functions inherited from OutputStream
| OutputStream (const std::string &name, ISvcLocator *pSvcLocator)
| Standard algorithm Constructor. More...
virtual | ~OutputStream ()=default
| Standard Destructor. More...
StatusCode | initialize () override
| Initialize OutputStream. More...
StatusCode | finalize () override
| Terminate OutputStream. More...
StatusCode | execute () override
| Working entry point. More...
virtual StatusCode | connectConversionSvc ()
virtual bool | collect (IRegistry *dir, int level)
| Store agent's classback. More...
virtual StatusCode | collectObjects ()
| Collect all objects to be written to the output stream. More...
void | clearSelection ()
| Clear list of selected objects. More...
Public Member Functions inherited from Algorithm
| Algorithm (const std::string &name, ISvcLocator *svcloc, const std::string &version=PACKAGE_VERSION)
| Constructor. More...
StatusCode | sysStart () override
| Reinitialization method invoked by the framework. More...
StatusCode | sysInitialize () override
| Initialization method invoked by the framework. More...
StatusCode | sysReinitialize () override
| Reinitialization method invoked by the framework. More...
StatusCode | sysRestart () override
| Restart method invoked by the framework. More...
StatusCode | sysExecute (const EventContext &ctx) override
| The actions to be performed by the algorithm on an event. More...
StatusCode | sysStop () override
| System stop. More...
StatusCode | sysFinalize () override
| System finalization. More...
StatusCode | sysBeginRun () override
| beginRun method invoked by the framework. More...
StatusCode | sysEndRun () override
| endRun method invoked by the framework. More...
const std::string & | name () const override
| The identifying name of the algorithm object. More...
const Gaudi::StringKey & | nameKey () const override
const std::string & | type () const override
| The type of the algorithm object. More...
void | setType (const std::string &type) override
const std::string & | version () const override
unsigned int | index () const override
StatusCode | configure () override
| Dummy implementation of IStateful::configure() method. More...
StatusCode | terminate () override
| Dummy implementation of IStateful::terminate() method. More...
StatusCode | initialize () override
| the default (empty) implementation of IStateful::initialize() method More...
StatusCode | start () override
| the default (empty) implementation of IStateful::start() method More...
StatusCode | stop () override
| the default (empty) implementation of IStateful::stop() method More...
StatusCode | finalize () override
| the default (empty) implementation of IStateful::finalize() method More...
StatusCode | reinitialize () override
| the default (empty) implementation of IStateful::reinitialize() method More...
StatusCode | restart () override
| the default (empty) implementation of IStateful::restart() method More...
Gaudi::StateMachine::State | FSMState () const override
| returns the current state of the algorithm More...
Gaudi::StateMachine::State | targetFSMState () const override
| returns the state the algorithm will be in after the ongoing transition More...
bool | isExecuted () const override
| Has this algorithm been executed since the last reset? More...
void | setExecuted (bool state) const override
| Set the executed flag to the specified state. More...
void | resetExecuted () override
| Reset the executed state of the Algorithm for the duration of the current event. More...
StatusCode | beginRun () override
| Algorithm begin run. More...
StatusCode | endRun () override
| Algorithm end run. This method is called at the end of the event loop. More...
bool | isEnabled () const override
| Is this algorithm enabled or disabled? More...
bool | isSequence () const override
| Are we a Sequence? More...
bool | filterPassed () const override
| Did this algorithm pass or fail its filter criterion for the last event? More...
void | setFilterPassed (bool state) const override
| Set the filter passed flag to the specified state. More...
unsigned int | errorCount () const
| Get the number of failures of the algorithm. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
SmartIF< IService > | service (const std::string &name, const bool createIf=true, const bool quiet=false) const
| Return a pointer to the service identified by name (or "type/name") More...
template<class T >
SmartIF< T > | service (const std::string &name, bool createIf=true, bool quiet=false) const
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
SmartIF< IChronoStatSvc > & | chronoSvc () const
| The standard Chrono & Stat service, Return a pointer to the service if present. More...
SmartIF< IChronoStatSvc > & | chronoStatService () const
SmartIF< IDataProviderSvc > & | detSvc () const
| The standard detector data service. More...
SmartIF< IDataProviderSvc > & | detDataService () const
SmartIF< IConversionSvc > & | detCnvSvc () const
| The standard detector data persistency conversion service. More...
SmartIF< IConversionSvc > & | detDataCnvService () const
SmartIF< IDataProviderSvc > & | eventSvc () const
| The standard event data service. More...
SmartIF< IDataProviderSvc > & | evtSvc () const
| shortcut for method eventSvc More...
SmartIF< IDataProviderSvc > & | eventDataService () const
SmartIF< IConversionSvc > & | eventCnvSvc () const
| The standard event data persistency conversion service. More...
SmartIF< IConversionSvc > & | eventDataCnvService () const
SmartIF< IHistogramSvc > & | histoSvc () const
| The standard histogram service. More...
SmartIF< IHistogramSvc > & | histogramDataService () const
SmartIF< INTupleSvc > & | ntupleSvc () const
| The standard N tuple service. More...
SmartIF< INTupleSvc > & | ntupleService () const
SmartIF< IRndmGenSvc > & | randSvc () const
| The standard RandomGen service, Return a pointer to the service if present. More...
SmartIF< IToolSvc > & | toolSvc () const
| The standard ToolSvc service, Return a pointer to the service if present. More...
SmartIF< IExceptionSvc > & | exceptionSvc () const
| Get the exception Service. More...
SmartIF< IAlgContextSvc > & | contextSvc () const
| get Algorithm Context Service More...
SmartIF< ITimelineSvc > & | timelineSvc () const
SmartIF< ISvcLocator > & | serviceLocator () const override
| The standard service locator. More...
SmartIF< ISvcLocator > & | svcLoc () const
| shortcut for method serviceLocator More...
SmartIF< IHiveWhiteBoard > & | whiteboard () const
SmartIF< IAlgExecStateSvc > & | algExecStateSvc () const
bool | registerContext () const
| register for Algorithm Context Service? More...
StatusCode | createSubAlgorithm (const std::string &type, const std::string &name, Algorithm *&pSubAlg)
| Create a sub algorithm. More...
const std::vector< Algorithm * > * | subAlgorithms () const
| List of sub-algorithms. Returns a pointer to a vector of (sub) Algorithms. More...
std::vector< Algorithm * > * | subAlgorithms ()
| List of sub-algorithms. Returns a pointer to a vector of (sub) Algorithms. More...
StatusCode | setProperties ()
| Set the algorithm's properties. More...
template<class T >
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, ToolHandle< T > &hndl, const std::string &doc="none")
template<class T >
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, ToolHandleArray< T > &hndlArr, const std::string &doc="none")
SmartIF< IMonitorSvc > & | monitorSvc () const
| Access the monitor service. More...
template<class T >
void | declareInfo (const std::string &name, const T &var, const std::string &desc) const
| Declare monitoring information. More...
void | declareInfo (const std::string &name, const std::string &format, const void *var, int size, const std::string &desc) const
| Declare monitoring information (special case) More...
const EventContext & | getContext () const override
| get the context More...
virtual void | acceptDHVisitor (IDataHandleVisitor *) const override
void | commitHandles () override
void | registerTool (IAlgTool *tool) const
void | deregisterTool (IAlgTool *tool) const
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
template<class T >
void | addToolsArray (ToolHandleArray< T > &hndlArr)
const std::vector< IAlgTool * > & | tools () const
bool | isIOBound () const
void | setIOBound (bool value)
unsigned int | cardinality () const override
| Return the cardinality. More...
const std::vector< std::string > & | neededResources () const override
std::ostream & | toControlFlowExpression (std::ostream &os) const override
| Produce string represention of the control flow expression. More...
Public Member Functions inherited from DataHandleHolderBase< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > >
std::vector< Gaudi::DataHandle * > | inputHandles () const override
std::vector< Gaudi::DataHandle * > | outputHandles () const override
virtual const DataObjIDColl & | extraInputDeps () const override
virtual const DataObjIDColl & | extraOutputDeps () const override
void | declare (Gaudi::DataHandle &handle) override
void | renounce (Gaudi::DataHandle &handle) override
const DataObjIDColl & | inputDataObjs () const override
const DataObjIDColl & | outputDataObjs () const override
void | addDependency (const DataObjID &id, const Gaudi::DataHandle::Mode &mode) override
Public Member Functions inherited from extends< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >, IDataHandleHolder >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Protected Member Functions
StatusCode | writeObjects () override
| OutputStream override: Select the different objects and write them to file. More...
virtual StatusCode | connectAddress ()
| Connect address column, if not already connected. More...
StatusCode | writeData ()
| Write data objects. More...
StatusCode | writeTuple ()
| Write tuple data. More...
StatusCode | writeRecord ()
| Write full event record. More...
Protected Member Functions inherited from OutputStream
StatusCode | decodeAcceptAlgs ()
| Decode list of Algorithms that this stream accepts. More...
void | acceptAlgsHandler (Gaudi::Details::PropertyBase &theProp)
| Handler for AcceptAlgs Property. More...
StatusCode | decodeRequireAlgs ()
| Decode list of Algorithms that this stream requires. More...
void | requireAlgsHandler (Gaudi::Details::PropertyBase &theProp)
| Handler for RequireAlgs Property. More...
StatusCode | decodeVetoAlgs ()
| Decode list of Algorithms that this stream is vetoed by. More...
void | vetoAlgsHandler (Gaudi::Details::PropertyBase &theProp)
| Handler for VetoAlgs Property. More...
Algorithm * | decodeAlgorithm (const std::string &theName)
| Decode a single algorithm name. More...
StatusCode | decodeAlgorithms (Gaudi::Property< std::vector< std::string >> &theNames, std::vector< Algorithm * > &theAlgs)
| Decode specified list of Algorithms. More...
bool | isEventAccepted () const
| Test whether this event should be output. More...
DataStoreItem * | findItem (const std::string &path)
| Find single item identified by its path (exact match) More...
virtual bool | hasInput () const
| Tell if the instance has been configured with input items or not. More...
Protected Member Functions inherited from Algorithm
std::vector< IAlgTool * > & | tools ()
bool | isInitialized () const override
| Has the Algorithm already been initialized? More...
bool | isFinalized () const override
| Has the Algorithm already been finalized? More...
void | setIndex (const unsigned int &idx) override
| set instantiation index of Alg More...
Protected Member Functions inherited from DataHandleHolderBase< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > >
void | initDataHandleHolder ()
| initializes all handles - called by the sysInitialize method of any descendant of this More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > >
MSG::Level | setUpMessaging ()
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Protected Attributes
Gaudi::Property< std::string > | m_addrLeaf
Gaudi::Property< std::string > | m_addrColName
Gaudi::Property< std::string > | m_collSvcName {this, "TagCollectionSvc", "NTupleSvc", "name of the collection service"}
Gaudi::Property< bool > | m_objectsFirst
Gaudi::Property< std::string > | m_tagName {this, "Collection", "", "name of the tag collection in the transient store"}
INTupleItem * | m_addrColumn = nullptr
| NTuple column to hold the opaque address of the address leaf. More...
std::string | m_topLeafName
| Name of the top leaf (performance cache) More...
bool | m_isTopLeaf = false
| Short cut flag to indicate if the address leaf is the top leaf (performace cache) More...
SmartIF< INTupleSvc > | m_collectionSvc
| Keep reference to the tuple service. More...
std::unique_ptr< GenericAddress > | m_addr
| Address buffer. More...
NTuple::Item< IOpaqueAddress * > | m_item
| Address item buffer. More...
Protected Attributes inherited from OutputStream
Gaudi::Property< ItemNames > | m_itemNames {this, "ItemList", {}, "vector of item names to be saved to this stream"}
Gaudi::Property< ItemNames > | m_optItemNames
Gaudi::Property< AlgDependentItemNames > | m_algDependentItemList
Gaudi::Property< bool > | m_doPreLoad
Gaudi::Property< bool > | m_doPreLoadOpt
Gaudi::Property< std::string > | m_output {this, "Output", {}, "name of the output file specification"}
Gaudi::Property< std::string > | m_outputName {this, "OutputFile", {}, "name of the output file"}
Gaudi::Property< std::string > | m_storeName
Gaudi::Property< std::string > | m_persName
Gaudi::Property< std::vector< std::string > > | m_acceptNames
Gaudi::Property< std::vector< std::string > > | m_requireNames
Gaudi::Property< std::vector< std::string > > | m_vetoNames
Gaudi::Property< bool > | m_verifyItems
bool | m_fireIncidents = true
| should I fire incidents for writing opening/closing etc? in the baseclass, always fire the incidents by default in e.g. More...
SmartIF< IIncidentSvc > | m_incidentSvc
| Reference to the incident service. More...
std::string | m_outputType = "UPDATE"
| Output type: NEW(NEW,CREATE,WRITE,RECREATE), UPDATE) More...
std::unique_ptr< OutputStreamAgent > | m_agent
| Keep reference of agent. More...
SmartIF< IDataProviderSvc > | m_pDataProvider
| Keep reference to the data provider service. More...
SmartIF< IDataManagerSvc > | m_pDataManager
| Keep reference to the data manager service. More...
SmartIF< IConversionSvc > | m_pConversionSvc
| Keep reference to the data conversion service. More...
DataStoreItem * | m_currentItem
| Keep track of the current item. More...
Items | m_itemList
| Vector of items to be saved to this stream. More...
Items | m_optItemList
| Vector of optional items to be saved to this stream. More...
AlgDependentItems | m_algDependentItems
| Items to be saved for specific algorithms. More...
IDataSelector | m_objects
| Collection of objects being selected. More...
int | m_events
| Number of events written to this output stream. More...
std::vector< Algorithm * > | m_acceptAlgs
| Vector of Algorithms that this stream accepts. More...
std::vector< Algorithm * > | m_requireAlgs
| Vector of Algorithms that this stream requires. More...
std::vector< Algorithm * > | m_vetoAlgs
| Vector of Algorithms that this stream is vetoed by. More...
Protected Attributes inherited from Algorithm
std::unique_ptr< IDataHandleVisitor > | m_updateDataHandles
| Hook for for derived classes to provide a custom visitor for data handles. More...
Protected Attributes inherited from DataHandleHolderBase< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > >
DataObjIDColl | m_inputDataObjs
DataObjIDColl | m_outputDataObjs

## Additional Inherited Members
Public Types inherited from OutputStream
typedef std::vector< DataStoreItem * > | Items
typedef std::vector< std::string > | ItemNames
typedef std::map< Algorithm *, Items > | AlgDependentItems
typedef std::map< std::string, ItemNames > | AlgDependentItemNames
Public Types inherited from Algorithm
typedef Gaudi::PluginService::Factory< IAlgorithm *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from extends< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >, IDataHandleHolder >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Public Attributes inherited from Algorithm
friend | AlgorithmManager

## Detailed Description

Specialized output stream class for event tag collections, where the basic Event entry point should be placed as well into the collection itself.

The TagCollectionStream is a rather specialized object combining features of NTuple I/O and object I/O. The main working points are:

1) Write a "normal" tag collection. The address column [property AddressColumn, default:"Address"] is added to the Ntuple identified by its name [mandatory property Collection]. The address column is set to the opaque address of the specified leaf [property "AddressLeaf", default:"/Event"]. The NTuple must be registered to the TES of the service [property: TagCollectionSvc, default:"NTupleSvc"]. This is the normal mode event tag collections work.

2) Write a tag collection with "REDIRECTED INPUT". Example: The collection is created from an intermediate file (MINI DST), but the Address column of the NTuple should point to the file e.g. containing the raw data.

- Set the property "AddressLeaf" to something different from "/Event" e.g. "/Event/DAQ/RawEvent"

Note: The actual address of "/Event" get changed. No other output should be created after writing such a tag collection.

3) Write an "EMBEDDED COLLECTION". In this mode the OutputStream and the NTuple stream are combined. depending on the property TagCollectionStream.ObjectsFirst the objects are written first and the the tags. The tag file and the file containing the objects may be identical.

Note:

- Also if the OutputStream features are NOT used, the options must still be properly set.
- Tags or objects are only written to the output stream if the event is accepted according to the output stream criteria (veto algorithms, etc.)
- If the address column is not present in the N-tuple (ie. it was not added by the N-tuple creator), it is automatically added at the first write attempt.
- If the logical N-tuple output file is not yet connected to the tuple service, it is automatically connected to the the same as the OutputStream device.

Author: M.Frank Version: 1.0

Definition at line 61 of file TagCollectionStream.h.

## Constructor & Destructor Documentation

TagCollectionStream::TagCollectionStream | ( | const std::string & | name,
|  | ISvcLocator * | pSvcLocator
| ) |  |

Standard algorithm Constructor.

Definition at line 17 of file TagCollectionStream.cpp.

18 : OutputStream( nam, pSvc ), m_addr{new GenericAddress()}
19 {
20 }
TagCollectionStream::m_addr
std::unique_ptr< GenericAddress > m_addr
Address buffer.
Definition: TagCollectionStream.h:82
GenericAddress
Generic Transient Address.
Definition: GenericAddress.h:20
OutputStream::OutputStream
OutputStream(const std::string &name, ISvcLocator *pSvcLocator)
Standard algorithm Constructor.
Definition: OutputStream.cpp:30

TagCollectionStream::~TagCollectionStream | ( |  | ) |
| override default

Standard Destructor.

## Member Function Documentation

StatusCode TagCollectionStream::connectAddress | ( |  | ) |
| protected virtual

Connect address column, if not already connected.

Definition at line 23 of file TagCollectionStream.cpp.

24 {
25 NTuplePtr nt( m_collectionSvc, m_tagName );
26 if ( !nt ) {
27 error() << "Failed to connect to the tag collection " << m_tagName << endmsg;
28 return StatusCode::FAILURE;
29 }
30 m_addrColumn = nt->find( m_addrColName );
31 if ( m_addrColumn ) return StatusCode::SUCCESS;
32 StatusCode sc = nt->addItem( m_addrColName, m_item );
33 if ( sc.isSuccess() ) {
34 m_addrColumn = m_item.operator->();
35 return sc;
36 }
37 error() << "Failed to add the address column:" << m_addrColName << " to the tag collection " << m_tagName << endmsg;
38 return sc;
39 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
StatusCode::FAILURE
Definition: StatusCode.h:31
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:75
TagCollectionStream::m_addrColName
Gaudi::Property< std::string > m_addrColName
Definition: TagCollectionStream.h:66
TagCollectionStream::m_addrColumn
INTupleItem * m_addrColumn
NTuple column to hold the opaque address of the address leaf.
Definition: TagCollectionStream.h:74
TagCollectionStream::m_collectionSvc
SmartIF< INTupleSvc > m_collectionSvc
Keep reference to the tuple service.
Definition: TagCollectionStream.h:80
TagCollectionStream::m_tagName
Gaudi::Property< std::string > m_tagName
Definition: TagCollectionStream.h:71
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:28
SmartDataPtr
A small class used to access easily (and efficiently) data items residing in data stores...
Definition: SmartDataPtr.h:47
TagCollectionStream::m_item
NTuple::Item< IOpaqueAddress * > m_item
Address item buffer.
Definition: TagCollectionStream.h:84
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209

StatusCode TagCollectionStream::finalize | ( |  | ) |
| override

Terminate TagCollectionStream.

Definition at line 94 of file TagCollectionStream.cpp.

95 {
96 StatusCode status = OutputStream::finalize();
97 m_collectionSvc.reset();
98 m_addrColumn = nullptr;
99 return status;
100 }
OutputStream::finalize
StatusCode finalize() override
Terminate OutputStream.
Definition: OutputStream.cpp:128
TagCollectionStream::m_addrColumn
INTupleItem * m_addrColumn
NTuple column to hold the opaque address of the address leaf.
Definition: TagCollectionStream.h:74
TagCollectionStream::m_collectionSvc
SmartIF< INTupleSvc > m_collectionSvc
Keep reference to the tuple service.
Definition: TagCollectionStream.h:80
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:28
SmartIF::reset
void reset(TYPE *ptr=nullptr)
Set the internal pointer to the passed one disposing of the old one.
Definition: SmartIF.h:92

StatusCode TagCollectionStream::initialize | ( |  | ) |
| override

Initialize TagCollectionStream.

Definition at line 42 of file TagCollectionStream.cpp.

43 {
44 using Parser = Gaudi::Utils::AttribStringParser;
45 std::string log_node, log_file, logical_name;
46 m_collectionSvc = service( m_collSvcName, true );
47 if ( m_collectionSvc ) {
48 std::string tmp;
49 for ( auto attrib : Parser( m_output ) ) {
50 switch (::toupper( attrib.tag[0] ) ) {
51 case 'C':
52 m_tagName = std::move( attrib.value );
53 break;
54 case 'A':
55 m_addrLeaf = std::move( attrib.value );
56 break;
57 default:
58 tmp += attrib.tag + "='" + attrib.value + "' ";
59 break;
60 }
61 }
62 m_output = std::move( tmp );
63 {
64 auto& tag = m_tagName.value();
65 std::string::size_type idx = ( tag[0] == SEPARATOR ) ? tag.find( SEPARATOR, 1 ) : 0;
66 log_node = tag.substr( idx, tag.find( SEPARATOR, idx + 1 ) );
67 }
68 log_file = log_node + " " + m_output + " SHARED='YES'";
69 }
70 m_addrColumn = nullptr; // reset pointer to item column
71 auto sc = OutputStream::initialize(); // Now initialize the base class
72 if ( sc.isSuccess() ) {
73 auto src_mgr = m_collectionSvc.as<IDataSourceMgr>();
74 if ( src_mgr ) {
75 auto data_mgr = m_collectionSvc.as<IDataManagerSvc>();
76 if ( data_mgr ) {
77 logical_name = data_mgr->rootName();
78 logical_name += SEPARATOR;
79 logical_name += log_node;
80 m_topLeafName =
81 m_addrLeaf.value().substr( 0, m_addrLeaf.value().find( SEPARATOR, m_addrLeaf[0] == '/' ? 1 : 0 ) );
82 m_isTopLeaf = m_topLeafName == m_addrLeaf;
83 if ( src_mgr->isConnected( logical_name ) ) return sc;
84 sc = src_mgr->connect( log_file );
85 if ( sc.isSuccess() ) return sc;
86 }
87 }
88 }
89 error() << "Failed to initialize TagCollection Stream." << endmsg;
90 return StatusCode::FAILURE;
91 }
Gaudi::Utils::AttribStringParser
Parse attribute strings allowing iteration over the various attributes.
Definition: AttribStringParser.h:32
SEPARATOR
constexpr char SEPARATOR
Definition: RegistryEntry.cpp:40
StatusCode::FAILURE
Definition: StatusCode.h:31
TagCollectionStream::m_addrLeaf
Gaudi::Property< std::string > m_addrLeaf
Definition: TagCollectionStream.h:64
OutputStream::m_output
Gaudi::Property< std::string > m_output
Definition: OutputStream.h:51
TagCollectionStream::m_addrColumn
INTupleItem * m_addrColumn
NTuple column to hold the opaque address of the address leaf.
Definition: TagCollectionStream.h:74
TagCollectionStream::m_collectionSvc
SmartIF< INTupleSvc > m_collectionSvc
Keep reference to the tuple service.
Definition: TagCollectionStream.h:80
TagCollectionStream::m_tagName
Gaudi::Property< std::string > m_tagName
Definition: TagCollectionStream.h:71
std::string
STL class.
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
SmartIF::as
SmartIF< IFace > as() const
return a new SmartIF instance to another interface
Definition: SmartIF.h:115
OutputStream::initialize
StatusCode initialize() override
Initialize OutputStream.
Definition: OutputStream.cpp:40
TagCollectionStream::m_collSvcName
Gaudi::Property< std::string > m_collSvcName
Definition: TagCollectionStream.h:68
std::move
T move(T...args)
IDataManagerSvc
Definition: IDataManagerSvc.h:45
IDataSourceMgr
IDataSourceMgr interface definition.
Definition: IDataSourceMgr.h:14
std::string::substr
T substr(T...args)
Algorithm::service
StatusCode service(const std::string &name, T *&psvc, bool createIf=true) const
Access a service by name, creating it if it doesn&#39;t already exist.
Definition: Algorithm.h:233
toupper
void toupper(std::string &s)
Definition: StatusCodeSvc.cpp:10
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
TagCollectionStream::m_isTopLeaf
bool m_isTopLeaf
Short cut flag to indicate if the address leaf is the top leaf (performace cache) ...
Definition: TagCollectionStream.h:78
TagCollectionStream::m_topLeafName
std::string m_topLeafName
Name of the top leaf (performance cache)
Definition: TagCollectionStream.h:76

StatusCode TagCollectionStream::writeData | ( |  | ) |
| protected

Write data objects.

Definition at line 114 of file TagCollectionStream.cpp.

115 {
116 StatusCode sc = OutputStream::writeObjects();
117 if ( !sc.isSuccess() ) {
118 error() << "Failed to write tag collection " << m_tagName << ". "
119 << "[Object write error]" << endmsg;
120 }
121 return sc;
122 }
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:75
TagCollectionStream::m_tagName
Gaudi::Property< std::string > m_tagName
Definition: TagCollectionStream.h:71
OutputStream::writeObjects
virtual StatusCode writeObjects()
Select the different objects and write them to file.
Definition: OutputStream.cpp:162
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:28
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209

StatusCode TagCollectionStream::writeObjects | ( |  | ) |
| override protected virtual

OutputStream override: Select the different objects and write them to file.

Reimplemented from OutputStream.

Definition at line 134 of file TagCollectionStream.cpp.

135 {
136 StatusCode status = !m_addrColumn ? connectAddress() : StatusCode::SUCCESS;
137 if ( status.isSuccess() ) {
138 status = m_objectsFirst ? writeData() : StatusCode::SUCCESS;
139 if ( status.isSuccess() && !m_addrColName.empty() ) {
140 SmartDataPtr<DataObject> top( eventSvc(), m_topLeafName );
141 if ( !top ) {
142 error() << "Failed to write tag collection " << m_tagName << ". " << m_topLeafName << " not found." << endmsg;
143 return StatusCode::FAILURE;
144 }
145 IOpaqueAddress* pA = top->registry()->address();
146 if ( !pA ) {
147 error() << "Failed to write tag collection " << m_tagName << ". " << m_topLeafName << "'s address not found."
148 << endmsg;
149 return StatusCode::FAILURE;
150 }
151 std::string* par = (std::string*)m_addr->par();
152 unsigned long* ipar = (unsigned long*)m_addr->ipar();
153 m_addr->setClID( pA->clID() );
154 m_addr->setSvcType( pA->svcType() );
155 par[0] = pA->par()[0];
156 par[1] = pA->par()[1];
157 ipar[0] = pA->ipar()[0];
158 ipar[1] = pA->ipar()[1];
159 *(IOpaqueAddress**)( m_addrColumn->buffer() ) = m_addr.get();
160 if ( m_isTopLeaf ) return writeRecord();
161 // Handle redirection mode. Normal tag collection mode
162 // is the same like leaving this out....
163 SmartDataPtr<DataObject> leaf( eventSvc(), m_addrLeaf );
164 if ( !leaf ) {
165 error() << "Failed to write tag collection " << m_tagName << ". " << m_addrLeaf << " not found." << endmsg;
166 return StatusCode::FAILURE;
167 }
168 IOpaqueAddress* redir = leaf->registry()->address();
169 if ( !redir ) {
170 error() << "Failed to write tag collection " << m_tagName << ". " << m_addrLeaf << "'s address not found."
171 << endmsg;
172 return StatusCode::FAILURE;
173 }
174 par[0] = redir->par()[0];
175 ipar[0] = ~0x0;
176 ipar[1] = redir->ipar()[1];
177 return writeRecord();
178 }
179 }
180 return status;
181 }
TagCollectionStream::connectAddress
virtual StatusCode connectAddress()
Connect address column, if not already connected.
Definition: TagCollectionStream.cpp:23
IOpaqueAddress::clID
virtual const CLID & clID() const =0
Retrieve class information from link.
TagCollectionStream::m_addr
std::unique_ptr< GenericAddress > m_addr
Address buffer.
Definition: TagCollectionStream.h:82
StatusCode::FAILURE
Definition: StatusCode.h:31
Algorithm::eventSvc
SmartIF< IDataProviderSvc > & eventSvc() const
The standard event data service.
Definition: Algorithm.cpp:798
GenericAddress::setSvcType
void setSvcType(long typ)
Access : set the storage type of the class id.
Definition: GenericAddress.h:82
TagCollectionStream::m_addrLeaf
Gaudi::Property< std::string > m_addrLeaf
Definition: TagCollectionStream.h:64
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:75
TagCollectionStream::m_objectsFirst
Gaudi::Property< bool > m_objectsFirst
Definition: TagCollectionStream.h:69
GaudiPython.Bindings.SUCCESS
SUCCESS
Definition: Bindings.py:56
TagCollectionStream::writeData
StatusCode writeData()
Write data objects.
Definition: TagCollectionStream.cpp:114
IOpaqueAddress::registry
virtual IRegistry * registry() const =0
Update branch name.
TagCollectionStream::m_addrColName
Gaudi::Property< std::string > m_addrColName
Definition: TagCollectionStream.h:66
TagCollectionStream::m_addrColumn
INTupleItem * m_addrColumn
NTuple column to hold the opaque address of the address leaf.
Definition: TagCollectionStream.h:74
IOpaqueAddress::par
virtual const std::string * par() const =0
Retrieve String parameters.
TagCollectionStream::m_tagName
Gaudi::Property< std::string > m_tagName
Definition: TagCollectionStream.h:71
std::string
STL class.
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
TagCollectionStream::writeRecord
StatusCode writeRecord()
Write full event record.
Definition: TagCollectionStream.cpp:125
GenericAddress::setClID
void setClID(const CLID &clid)
Access : Set class ID of the link.
Definition: GenericAddress.h:78
compareOutputFiles.par
string par
Definition: compareOutputFiles.py:437
IOpaqueAddress::ipar
virtual const unsigned long * ipar() const =0
Access to generic link parameters.
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:28
GenericAddress::ipar
const unsigned long * ipar() const override
Retrieve integer parameters.
Definition: GenericAddress.h:86
GenericAddress::par
const std::string * par() const override
Retrieve string parameters.
Definition: GenericAddress.h:84
IOpaqueAddress::svcType
virtual long svcType() const =0
Retrieve service type.
INTupleItem::buffer
virtual const void * buffer() const =0
Access data buffer (CONST)
std::unique_ptr::get
T get(T...args)
HiveAlgSequencer.top
top
Definition: HiveAlgSequencer.py:29
SmartDataPtr
A small class used to access easily (and efficiently) data items residing in data stores...
Definition: SmartDataPtr.h:47
IOpaqueAddress
Opaque address interface definition.
Definition: IOpaqueAddress.h:23
IRegistry::address
virtual IOpaqueAddress * address() const =0
Retrieve opaque storage address.
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
TagCollectionStream::m_isTopLeaf
bool m_isTopLeaf
Short cut flag to indicate if the address leaf is the top leaf (performace cache) ...
Definition: TagCollectionStream.h:78
TagCollectionStream::m_topLeafName
std::string m_topLeafName
Name of the top leaf (performance cache)
Definition: TagCollectionStream.h:76

StatusCode TagCollectionStream::writeRecord | ( |  | ) |
| protected

Write full event record.

Definition at line 125 of file TagCollectionStream.cpp.

126 {
127 if ( writeTuple().isSuccess() ) {
128 return m_objectsFirst ? StatusCode::SUCCESS : writeData();
129 }
130 return StatusCode::FAILURE;
131 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
StatusCode::FAILURE
Definition: StatusCode.h:31
TagCollectionStream::m_objectsFirst
Gaudi::Property< bool > m_objectsFirst
Definition: TagCollectionStream.h:69
TagCollectionStream::writeData
StatusCode writeData()
Write data objects.
Definition: TagCollectionStream.cpp:114
TagCollectionStream::writeTuple
StatusCode writeTuple()
Write tuple data.
Definition: TagCollectionStream.cpp:103

StatusCode TagCollectionStream::writeTuple | ( |  | ) |
| protected

Write tuple data.

Definition at line 103 of file TagCollectionStream.cpp.

104 {
105 StatusCode sc = m_collectionSvc->writeRecord( m_tagName );
106 if ( !sc.isSuccess() ) {
107 error() << "Failed to write tag collection " << m_tagName << ". "
108 << "[Tuple write error]" << endmsg;
109 }
110 return sc;
111 }
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:75
TagCollectionStream::m_collectionSvc
SmartIF< INTupleSvc > m_collectionSvc
Keep reference to the tuple service.
Definition: TagCollectionStream.h:80
TagCollectionStream::m_tagName
Gaudi::Property< std::string > m_tagName
Definition: TagCollectionStream.h:71
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:28
INTupleSvc::writeRecord
virtual StatusCode writeRecord(NTuple::Tuple *tuple)=0
Write single record to N tuple.
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209

## Member Data Documentation

std::unique_ptr<GenericAddress> TagCollectionStream::m_addr
| protected

Address buffer.

Definition at line 82 of file TagCollectionStream.h.

Gaudi::Property<std::string> TagCollectionStream::m_addrColName
| protected

Initial value:
{this, "AddressColumn", "Address",
"name of the address column of the tag collection"}

Definition at line 66 of file TagCollectionStream.h.

INTupleItem* TagCollectionStream::m_addrColumn = nullptr
| protected

NTuple column to hold the opaque address of the address leaf.

Definition at line 74 of file TagCollectionStream.h.

Gaudi::Property<std::string> TagCollectionStream::m_addrLeaf
| protected

Initial value:
{this, "AddressLeaf", "/Event",
"name of the address leaf in the transient event store"}

Definition at line 64 of file TagCollectionStream.h.

SmartIF<INTupleSvc> TagCollectionStream::m_collectionSvc
| protected

Keep reference to the tuple service.

Definition at line 80 of file TagCollectionStream.h.

Gaudi::Property<std::string> TagCollectionStream::m_collSvcName {this, "TagCollectionSvc", "NTupleSvc", "name of the collection service"}
| protected

Definition at line 68 of file TagCollectionStream.h.

bool TagCollectionStream::m_isTopLeaf = false
| protected

Short cut flag to indicate if the address leaf is the top leaf (performace cache)

Definition at line 78 of file TagCollectionStream.h.

NTuple::Item<IOpaqueAddress*> TagCollectionStream::m_item
| protected

Address item buffer.

Definition at line 84 of file TagCollectionStream.h.

Gaudi::Property<bool> TagCollectionStream::m_objectsFirst
| protected

Initial value:
{this, "ObjectsFirst", true,
"flag to indicate that the objects should be written first"}

Definition at line 69 of file TagCollectionStream.h.

Gaudi::Property<std::string> TagCollectionStream::m_tagName {this, "Collection", "", "name of the tag collection in the transient store"}
| protected

Definition at line 71 of file TagCollectionStream.h.

std::string TagCollectionStream::m_topLeafName
| protected

Name of the top leaf (performance cache)

Definition at line 76 of file TagCollectionStream.h.

The documentation for this class was generated from the following files:

- GaudiCommonSvc/src/PersistencySvc/TagCollectionStream.h
- GaudiCommonSvc/src/PersistencySvc/TagCollectionStream.cpp